// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: commonmodule/commonmodule.proto

package openfmb.commonmodule;

/**
 * <pre>
 * Calculation method (CalcMethodKind enumeration)
 * </pre>
 *
 * Protobuf enum {@code commonmodule.CalcMethodKind}
 */
public enum CalcMethodKind
    implements com.google.protobuf.ProtocolMessageEnum {
  /**
   * <pre>
   * Undefined enum value which can be used for Protobuf generation and be consistent with other
   * technologies.
   * </pre>
   *
   * <code>CalcMethodKind_UNDEFINED = 0;</code>
   */
  CalcMethodKind_UNDEFINED(0),
  /**
   * <pre>
   * All analogue values (i.e., all common attributes 'i' and 'f') meet the sampling and filtering
   * characteristics specified in IEEE C37.118.1 for P-CLASS.
   * </pre>
   *
   * <code>CalcMethodKind_P_CLASS = 11;</code>
   */
  CalcMethodKind_P_CLASS(11),
  /**
   * <pre>
   * All analogue values (i.e., all common attributes 'i' and 'f') meet the sampling and filtering
   * characteristics specified in IEEE C37.118.1 for M-CLASS.
   * </pre>
   *
   * <code>CalcMethodKind_M_CLASS = 12;</code>
   */
  CalcMethodKind_M_CLASS(12),
  /**
   * <pre>
   * All analogue values are [F(t+T)-F(t)] for a calculation interval T (in the same unit as the
   * original entity). Note: The client can still calculate rate so: RATE = DIFF/T.
   * </pre>
   *
   * <code>CalcMethodKind_DIFF = 13;</code>
   */
  CalcMethodKind_DIFF(13),
  UNRECOGNIZED(-1),
  ;

  /**
   * <pre>
   * Undefined enum value which can be used for Protobuf generation and be consistent with other
   * technologies.
   * </pre>
   *
   * <code>CalcMethodKind_UNDEFINED = 0;</code>
   */
  public static final int CalcMethodKind_UNDEFINED_VALUE = 0;
  /**
   * <pre>
   * All analogue values (i.e., all common attributes 'i' and 'f') meet the sampling and filtering
   * characteristics specified in IEEE C37.118.1 for P-CLASS.
   * </pre>
   *
   * <code>CalcMethodKind_P_CLASS = 11;</code>
   */
  public static final int CalcMethodKind_P_CLASS_VALUE = 11;
  /**
   * <pre>
   * All analogue values (i.e., all common attributes 'i' and 'f') meet the sampling and filtering
   * characteristics specified in IEEE C37.118.1 for M-CLASS.
   * </pre>
   *
   * <code>CalcMethodKind_M_CLASS = 12;</code>
   */
  public static final int CalcMethodKind_M_CLASS_VALUE = 12;
  /**
   * <pre>
   * All analogue values are [F(t+T)-F(t)] for a calculation interval T (in the same unit as the
   * original entity). Note: The client can still calculate rate so: RATE = DIFF/T.
   * </pre>
   *
   * <code>CalcMethodKind_DIFF = 13;</code>
   */
  public static final int CalcMethodKind_DIFF_VALUE = 13;


  public final int getNumber() {
    if (this == UNRECOGNIZED) {
      throw new java.lang.IllegalArgumentException(
          "Can't get the number of an unknown enum value.");
    }
    return value;
  }

  /**
   * @param value The numeric wire value of the corresponding enum entry.
   * @return The enum associated with the given numeric wire value.
   * @deprecated Use {@link #forNumber(int)} instead.
   */
  @java.lang.Deprecated
  public static CalcMethodKind valueOf(int value) {
    return forNumber(value);
  }

  /**
   * @param value The numeric wire value of the corresponding enum entry.
   * @return The enum associated with the given numeric wire value.
   */
  public static CalcMethodKind forNumber(int value) {
    switch (value) {
      case 0: return CalcMethodKind_UNDEFINED;
      case 11: return CalcMethodKind_P_CLASS;
      case 12: return CalcMethodKind_M_CLASS;
      case 13: return CalcMethodKind_DIFF;
      default: return null;
    }
  }

  public static com.google.protobuf.Internal.EnumLiteMap<CalcMethodKind>
      internalGetValueMap() {
    return internalValueMap;
  }
  private static final com.google.protobuf.Internal.EnumLiteMap<
      CalcMethodKind> internalValueMap =
        new com.google.protobuf.Internal.EnumLiteMap<CalcMethodKind>() {
          public CalcMethodKind findValueByNumber(int number) {
            return CalcMethodKind.forNumber(number);
          }
        };

  public final com.google.protobuf.Descriptors.EnumValueDescriptor
      getValueDescriptor() {
    if (this == UNRECOGNIZED) {
      throw new java.lang.IllegalStateException(
          "Can't get the descriptor of an unrecognized enum value.");
    }
    return getDescriptor().getValues().get(ordinal());
  }
  public final com.google.protobuf.Descriptors.EnumDescriptor
      getDescriptorForType() {
    return getDescriptor();
  }
  public static final com.google.protobuf.Descriptors.EnumDescriptor
      getDescriptor() {
    return openfmb.commonmodule.Commonmodule.getDescriptor().getEnumTypes().get(9);
  }

  private static final CalcMethodKind[] VALUES = values();

  public static CalcMethodKind valueOf(
      com.google.protobuf.Descriptors.EnumValueDescriptor desc) {
    if (desc.getType() != getDescriptor()) {
      throw new java.lang.IllegalArgumentException(
        "EnumValueDescriptor is not for this type.");
    }
    if (desc.getIndex() == -1) {
      return UNRECOGNIZED;
    }
    return VALUES[desc.getIndex()];
  }

  private final int value;

  private CalcMethodKind(int value) {
    this.value = value;
  }

  // @@protoc_insertion_point(enum_scope:commonmodule.CalcMethodKind)
}

